/**
 * <copyright>
 * </copyright>
 *
 * $Id: DataTypeAndTypeParameterImpl.java 7485 2011-04-13 10:23:04Z hoenninger $
 */
package org.openxma.dsl.core.model.impl;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.openxma.dsl.core.CorePackage;
import org.openxma.dsl.core.model.DataTypeAndTypeParameter;
import org.openxma.dsl.core.model.ParameterDefinition;
import org.openxma.dsl.core.model.ReferenceWithParameter;
import org.openxma.dsl.core.model.SimpleType;
import org.openxma.dsl.core.model.Type;
import org.openxma.dsl.core.model.TypeDefinition;
import org.openxma.dsl.core.model.ValidatorReference;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Data Type And Type Parameter</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.openxma.dsl.core.model.impl.DataTypeAndTypeParameterImpl#getDataType <em>Data Type</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DataTypeAndTypeParameterImpl extends ReferenceWithParameterImpl implements DataTypeAndTypeParameter {
	/**
	 * The cached value of the '{@link #getDataType() <em>Data Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataType()
	 * @generated
	 * @ordered
	 */
	protected Type dataType;

	/**
	 *
    * @modified
	 */
	protected ValidatorReference validatorReference;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataTypeAndTypeParameterImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return CorePackage.Literals.DATA_TYPE_AND_TYPE_PARAMETER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Type getDataType() {
		if (dataType != null && dataType.eIsProxy()) {
			InternalEObject oldDataType = (InternalEObject)dataType;
			dataType = (Type)eResolveProxy(oldDataType);
			if (dataType != oldDataType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CorePackage.DATA_TYPE_AND_TYPE_PARAMETER__DATA_TYPE, oldDataType, dataType));
			}
		}
		return dataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Type basicGetDataType() {
		return dataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDataType(Type newDataType) {
		Type oldDataType = dataType;
		dataType = newDataType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.DATA_TYPE_AND_TYPE_PARAMETER__DATA_TYPE, oldDataType, dataType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CorePackage.DATA_TYPE_AND_TYPE_PARAMETER__DATA_TYPE:
				if (resolve) return getDataType();
				return basicGetDataType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CorePackage.DATA_TYPE_AND_TYPE_PARAMETER__DATA_TYPE:
				setDataType((Type)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case CorePackage.DATA_TYPE_AND_TYPE_PARAMETER__DATA_TYPE:
				setDataType((Type)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CorePackage.DATA_TYPE_AND_TYPE_PARAMETER__DATA_TYPE:
				return dataType != null;
		}
		return super.eIsSet(featureID);
	}

	/**
     * @modified
	 * @return
	 */
	public List<ReferenceWithParameter> getDefinitionStack() {
		if (definitionStack == null) {
            definitionStack = new ArrayList<ReferenceWithParameter>();		    
		    Type type = getDataType();
		    // Return empty definition stack when dataType is not a SimpleType
		    if (!(type instanceof SimpleType)) {
		        return definitionStack;
		    }
		    SimpleType simpleType = (SimpleType)type;		    
			definitionStack.add(this);			
			ValidatorReference validatorReference = simpleType.getValidatorReference();
			if (validatorReference != null) {
				definitionStack.addAll(validatorReference.getDefinitionStack());					
			} else {			
				TypeDefinition typeDefinition = simpleType.getTypeDefinition();			
				if (typeDefinition != null && typeDefinition.getDefinition() != null) {
					DataTypeAndTypeParameter baseDef = typeDefinition.getDefinition();
					definitionStack.addAll(baseDef.getDefinitionStack());
				}
			}
		}
		return definitionStack;
	}

	/**
	 *
     * @modified
	 * @return
	 */
	public ValidatorReference getValidatorReferenceDefinition() {
		if (validatorReference == null) {
			List<ReferenceWithParameter> stack = getDefinitionStack();
			if (stack != null && stack.size() > 0) {
				ReferenceWithParameter referenceWithParameter =	stack.get(stack.size() - 1);
				if (referenceWithParameter instanceof DataTypeAndTypeParameter) {
					DataTypeAndTypeParameter baseDefinition = (DataTypeAndTypeParameter)referenceWithParameter;
					validatorReference = ((SimpleType) baseDefinition.getDataType()).getValidatorReference();		
				} else if (referenceWithParameter instanceof ValidatorReference) { 
					validatorReference = (ValidatorReference)referenceWithParameter;			
				} else {
					throw new RuntimeException("Next element in definition-stack is of unexpected type");
				}				
			}
		}
		return validatorReference;
	}

	@Override
	public List<ParameterDefinition> getParameterDefinitions() {		
		Type type = getDataType();
		if (type instanceof SimpleType) {
			SimpleType simpleType = (SimpleType)type;
			return simpleType.getTypeParameter();
		}
		return null;
	}	

} //DataTypeAndTypeParameterImpl
